Index: cpukit/libfs/src/dosfs/msdos_create.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_create.c,v
retrieving revision 1.13
diff -p -u -u -r1.13 msdos_create.c
--- cpukit/libfs/src/dosfs/msdos_create.c	29 Jul 2008 02:21:14 -0000	1.13
+++ cpukit/libfs/src/dosfs/msdos_create.c	23 Apr 2009 07:54:40 -0000
@@ -17,6 +17,7 @@
 
 #include <errno.h>
 #include <assert.h>
+#include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <rtems/libio_.h>
@@ -29,7 +30,14 @@
 #include "msdos.h"
 
 /* msdos_creat_node --
- *     Create a new node. If a new node is file, FAT 32 Bytes Directory
+ *     Create a new node. Determine if the name is a long name. If long we to
+ *     scan the directory to create a short entry.
+ *
+ *
+
+
+
+ *     If a new node is file, FAT 32 Bytes Directory
  *     Entry Structure is initialized, free space is found in parent
  *     directory and structure is written to the disk. In case of directory,
  *     all above steps present and also new cluster is allocated for a
@@ -48,52 +56,55 @@
  *
  */
 int
-msdos_creat_node(
-    rtems_filesystem_location_info_t  *parent_loc,
-    msdos_node_type_t                  type,
-    char                              *name,
-    mode_t                             mode,
-    const fat_file_fd_t               *link_fd
-    )
+msdos_creat_node(rtems_filesystem_location_info_t  *parent_loc,
+                 msdos_node_type_t                  type,
+                 const char                        *name,
+                 int                                name_len,
+                 mode_t                             mode,
+                 const fat_file_fd_t               *link_fd)
 {
-    int              rc = RC_OK;
-    ssize_t          ret = 0;
-    msdos_fs_info_t *fs_info = parent_loc->mt_entry->fs_info;
-    fat_file_fd_t   *parent_fat_fd = parent_loc->node_access;
-    fat_file_fd_t   *fat_fd = NULL;
-    time_t           time_ret = 0;
-    uint16_t         time_val = 0;
-    uint16_t         date = 0;
-    fat_auxiliary_t  aux;
-    char             new_node  [MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
-    char             dot_dotdot[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE * 2];
-    char             link_node [MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
-    uint32_t         sec = 0;
-    uint32_t         byte = 0;
-
-    memset(new_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+    int               rc = RC_OK;
+    ssize_t           ret = 0;
+    msdos_fs_info_t  *fs_info = parent_loc->mt_entry->fs_info;
+    fat_file_fd_t    *parent_fat_fd = parent_loc->node_access;
+    fat_file_fd_t    *fat_fd = NULL;
+    time_t            time_ret = 0;
+    uint16_t          time_val = 0;
+    uint16_t          date = 0;
+    fat_dir_pos_t     dir_pos;
+    msdos_name_type_t name_type;
+    char              short_node[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
+    char              dot_dotdot[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE * 2];
+    char              link_node[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
+    uint32_t          sec = 0;
+    uint32_t          byte = 0;
+
+    fat_dir_pos_init(&dir_pos);
+    
+    memset(short_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
     memset(dot_dotdot, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE * 2);
 
-    /* set up name */
-    strncpy(MSDOS_DIR_NAME(new_node), name, MSDOS_NAME_MAX);
+    name_type = msdos_long_to_short (name, name_len,
+                                     MSDOS_DIR_NAME(short_node),
+                                     MSDOS_NAME_MAX);
 
     /* fill reserved field */
-    *MSDOS_DIR_NT_RES(new_node) = MSDOS_RES_NT_VALUE;
+    *MSDOS_DIR_NT_RES(short_node) = MSDOS_RES_NT_VALUE;
 
     /* set up last write date and time */
     time_ret = time(NULL);
     if ( time_ret == -1 )
         return -1;
 
-    msdos_date_unix2dos(time_ret, &time_val, &date);
-    *MSDOS_DIR_WRITE_TIME(new_node) = CT_LE_W(time_val);
-    *MSDOS_DIR_WRITE_DATE(new_node) = CT_LE_W(date);
+    msdos_date_unix2dos(time_ret, &date, &time_val);
+    *MSDOS_DIR_WRITE_TIME(short_node) = CT_LE_W(time_val);
+    *MSDOS_DIR_WRITE_DATE(short_node) = CT_LE_W(date);
 
     /* initialize directory/file size */
-    *MSDOS_DIR_FILE_SIZE(new_node) = MSDOS_INIT_DIR_SIZE;
+    *MSDOS_DIR_FILE_SIZE(short_node) = MSDOS_INIT_DIR_SIZE;
 
-    if (type == MSDOS_DIRECTORY){
-        *MSDOS_DIR_ATTR(new_node) |= MSDOS_ATTR_DIRECTORY;
+    if (type == MSDOS_DIRECTORY) {
+      *MSDOS_DIR_ATTR(short_node) |= MSDOS_ATTR_DIRECTORY;
     }
     else if (type == MSDOS_HARD_LINK) {
       /*
@@ -105,51 +116,52 @@ msdos_creat_node(
        * read the original directory entry
        */
       sec = fat_cluster_num_to_sector_num(parent_loc->mt_entry,
-					  link_fd->info_cln);
-      sec += (link_fd->info_ofs >> fs_info->fat.vol.sec_log2);
-      byte = (link_fd->info_ofs & (fs_info->fat.vol.bps - 1));
+                                          link_fd->dir_pos.sname.cln);
+      sec += (link_fd->dir_pos.sname.ofs >> fs_info->fat.vol.sec_log2);
+      byte = (link_fd->dir_pos.sname.ofs & (fs_info->fat.vol.bps - 1));
 
       ret = _fat_block_read(parent_loc->mt_entry,
-			    sec, byte, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE,
+                            sec, byte, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE,
                             link_node);
       if (ret < 0) {
-	return -1;
+          return -1;
       }
       /*
        * copy various attributes
        */
-      *MSDOS_DIR_ATTR(new_node)          =*MSDOS_DIR_ATTR(link_node);
-      *MSDOS_DIR_CRT_TIME_TENTH(new_node)=*MSDOS_DIR_CRT_TIME_TENTH(link_node);
-      *MSDOS_DIR_CRT_TIME(new_node)      =*MSDOS_DIR_CRT_TIME(link_node);
-      *MSDOS_DIR_CRT_DATE(new_node)      =*MSDOS_DIR_CRT_DATE(link_node);
+      *MSDOS_DIR_ATTR(short_node)          =*MSDOS_DIR_ATTR(link_node);
+      *MSDOS_DIR_CRT_TIME_TENTH(short_node)=*MSDOS_DIR_CRT_TIME_TENTH(link_node);
+      *MSDOS_DIR_CRT_TIME(short_node)      =*MSDOS_DIR_CRT_TIME(link_node);
+      *MSDOS_DIR_CRT_DATE(short_node)      =*MSDOS_DIR_CRT_DATE(link_node);
 
       /*
        * copy/set "file size", "first cluster"
        */
-      *MSDOS_DIR_FILE_SIZE(new_node)     =*MSDOS_DIR_FILE_SIZE(link_node);
+      *MSDOS_DIR_FILE_SIZE(short_node)     =*MSDOS_DIR_FILE_SIZE(link_node);
 
-      *MSDOS_DIR_FIRST_CLUSTER_LOW(new_node) =
+      *MSDOS_DIR_FIRST_CLUSTER_LOW(short_node) =
            *MSDOS_DIR_FIRST_CLUSTER_LOW(link_node);
-      *MSDOS_DIR_FIRST_CLUSTER_HI(new_node) =
+      *MSDOS_DIR_FIRST_CLUSTER_HI(short_node) =
            *MSDOS_DIR_FIRST_CLUSTER_HI(link_node);
       /*
        * set "archive bit" due to changes
        */
-      *MSDOS_DIR_ATTR(new_node) |= MSDOS_ATTR_ARCHIVE;
+      *MSDOS_DIR_ATTR(short_node) |= MSDOS_ATTR_ARCHIVE;
       /*
        * set "last access" date to today
        */
-      *MSDOS_DIR_LAST_ACCESS_DATE(new_node) = CT_LE_W(date);
+      *MSDOS_DIR_LAST_ACCESS_DATE(short_node) = CT_LE_W(date);
     }
     else { /* regular file... */
-        *MSDOS_DIR_ATTR(new_node) |= MSDOS_ATTR_ARCHIVE;
+        *MSDOS_DIR_ATTR(short_node) |= MSDOS_ATTR_ARCHIVE;
     }
 
     /*
      * find free space in the parent directory and write new initialized
      * FAT 32 Bytes Directory Entry Structure to the disk
      */
-    rc = msdos_get_name_node(parent_loc, NULL, &aux, new_node);
+    rc = msdos_get_name_node(parent_loc, true, name, name_len,
+                             name_type, &dir_pos, short_node);
     if ( rc != RC_OK )
         return rc;
 
@@ -160,7 +172,7 @@ msdos_creat_node(
     if (type == MSDOS_DIRECTORY)
     {
         /* open new directory as fat-file */
-        rc = fat_file_open(parent_loc->mt_entry, aux.cln, aux.ofs, &fat_fd);
+        rc = fat_file_open(parent_loc->mt_entry, &dir_pos, &fat_fd);
         if (rc != RC_OK)
             goto err;
 
@@ -168,8 +180,6 @@ msdos_creat_node(
          * we opened fat-file for node we just created, so initialize fat-file
          * descritor
          */
-        fat_fd->info_cln = aux.cln;
-        fat_fd->info_ofs = aux.ofs;
         fat_fd->fat_file_size = 0;
         fat_fd->fat_file_type = FAT_DIRECTORY;
         fat_fd->size_limit = MSDOS_MAX_DIR_LENGHT;
@@ -178,9 +188,9 @@ msdos_creat_node(
          * dot and dotdot entries are identical to new node except the
          * names
          */
-        memcpy(DOT_NODE_P(dot_dotdot), new_node,
+        memcpy(DOT_NODE_P(dot_dotdot), short_node,
                MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-        memcpy(DOTDOT_NODE_P(dot_dotdot), new_node,
+        memcpy(DOTDOT_NODE_P(dot_dotdot), short_node,
                MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
         memcpy(MSDOS_DIR_NAME(DOT_NODE_P(dot_dotdot)), MSDOS_DOT_NAME,
                MSDOS_NAME_MAX);
@@ -253,9 +263,8 @@ error:
     fat_file_close(parent_loc->mt_entry, fat_fd);
 
 err:
-    /* mark 32bytes structure on the disk as free */
-    msdos_set_first_char4file_name(parent_loc->mt_entry, aux.cln, aux.ofs,
-                                   0xE5);
+    /* mark the used 32bytes structure on the disk as free */
+    msdos_set_first_char4file_name(parent_loc->mt_entry, &dir_pos, 0xE5);
     return rc;
 }
 
@@ -287,21 +296,21 @@ err:
  */
 int
 msdos_file_link(rtems_filesystem_location_info_t *to_loc,
-		rtems_filesystem_location_info_t *par_loc,
-		const char                       *token
+                rtems_filesystem_location_info_t *par_loc,
+                const char                       *name
 )
 {
     int                rc = RC_OK;
     rtems_status_code  sc = RTEMS_SUCCESSFUL;
     msdos_fs_info_t   *fs_info     = to_loc->mt_entry->fs_info;
     fat_file_fd_t     *to_fat_fd   = to_loc->node_access;
-    char               new_name[ MSDOS_NAME_MAX + 1 ];
+    const char        *token;
     int                len;
 
     /*
      * check spelling and format new node name
      */
-    if (MSDOS_NAME != msdos_get_token(token, new_name, &len)) {
+    if (MSDOS_NAME != msdos_get_token(name, &token, &len)) {
       rtems_set_errno_and_return_minus_one(ENAMETOOLONG);
     }
     /*
@@ -324,8 +333,8 @@ msdos_file_link(rtems_filesystem_locatio
      * create new directory entry as "hard link",
      * copying relevant info from existing file
      */
-    rc = msdos_creat_node(par_loc,MSDOS_HARD_LINK,new_name,S_IFREG,
-			  to_loc->node_access);
+    rc = msdos_creat_node(par_loc,MSDOS_HARD_LINK,name,len,S_IFREG,
+                          to_loc->node_access);
     /*
      * set file size and first cluster number of old entry to 0
      */
Index: cpukit/libfs/src/dosfs/msdos_dir.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_dir.c,v
retrieving revision 1.13
diff -p -u -u -r1.13 msdos_dir.c
--- cpukit/libfs/src/dosfs/msdos_dir.c	9 Mar 2009 14:11:23 -0000	1.13
+++ cpukit/libfs/src/dosfs/msdos_dir.c	23 Apr 2009 07:54:40 -0000
@@ -14,6 +14,7 @@
 #include "config.h"
 #endif
 
+#include <ctype.h> 
 #include <stdlib.h>
 #include <unistd.h>
 #include <assert.h>
@@ -145,7 +146,7 @@ msdos_format_dirent_with_dot(char *dst,c
   src_tmp = src;
   len = i;
   while (i-- > 0) {
-    *dst++ = *src_tmp++;
+    *dst++ = tolower(*src_tmp++);
   }
   /*
    * find last non-blank character of extension
@@ -164,7 +165,7 @@ msdos_format_dirent_with_dot(char *dst,c
     len += i + 1; /* extension + dot */
     src_tmp = src + MSDOS_SHORT_BASE_LEN;
     while (i-- > 0) {
-      *dst++ = *src_tmp++;
+      *dst++ = tolower(*src_tmp++);
       len++;
     }
   }
@@ -210,6 +211,9 @@ msdos_dir_read(rtems_libio_t *iop, void 
     uint32_t           j = 0, i = 0;
     uint32_t           bts2rd = 0;
     uint32_t           cur_cln = 0;
+    uint32_t           lfn_start = FAT_FILE_SHORT_NAME;
+    uint8_t            lfn_checksum = 0;
+    int                lfn_entries = 0;
 
     /*
      * cast start and count - protect against using sizes that are not exact
@@ -253,80 +257,211 @@ msdos_dir_read(rtems_libio_t *iop, void 
 
         for (i = 0; i < ret; i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
-            if ((*MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
+            char* entry = (char*) fs_info->cl_buf + i;
+            
+            /*
+             * Is this directory from here on empty ?
+             */
+            if ((*MSDOS_DIR_ENTRY_TYPE(entry)) ==
                 MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY)
             {
                 rtems_semaphore_release(fs_info->vol_sema);
                 return cmpltd;
             }
 
-            /* have to look at the DIR_NAME as "raw" 8-bit data */
-            if ((*(uint8_t *)MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
-                MSDOS_THIS_DIR_ENTRY_EMPTY)
+            /* Is the directory entry empty */
+            if ((*MSDOS_DIR_ENTRY_TYPE(entry)) == MSDOS_THIS_DIR_ENTRY_EMPTY)
                 continue;
 
-            /*
-             * skip active entries until get the entry to start from
-             */
-            if (start)
-            {
-                start--;
+            /* Is the directory entry empty a volume label */
+            if (((*MSDOS_DIR_ATTR(entry)) & MSDOS_ATTR_VOLUME_ID) &&
+                ((*MSDOS_DIR_ATTR(entry) & MSDOS_ATTR_LFN_MASK) != MSDOS_ATTR_LFN))
                 continue;
-            }
 
             /*
-             * Move the entry to the return buffer
-             *
-             * unfortunately there is no method to extract ino except to
-             * open fat-file descriptor :( ... so, open it
+             * Check the attribute to see if the entry is for a long file
+             * name.
              */
-
-            /* get number of cluster we are working with */
-            rc = fat_file_ioctl(iop->pathinfo.mt_entry, fat_fd, F_CLU_NUM,
-                                j * bts2rd, &cur_cln);
-            if (rc != RC_OK)
+            if ((*MSDOS_DIR_ATTR(entry) & MSDOS_ATTR_LFN_MASK) ==
+                MSDOS_ATTR_LFN)
             {
-                rtems_semaphore_release(fs_info->vol_sema);
-                return rc;
-            }
-
-            rc = fat_file_open(iop->pathinfo.mt_entry, cur_cln, i,
-                               &tmp_fat_fd);
-            if (rc != RC_OK)
-            {
-                rtems_semaphore_release(fs_info->vol_sema);
-                return rc;
+                int   o;
+                char* p;
+                int   q;
+                
+                /*
+                 * Is this is the first entry of a LFN ?
+                 */
+                if (lfn_start == FAT_FILE_SHORT_NAME)
+                {
+                    /*
+                     * The first entry must have the last long entry flag set.
+                     */
+                    if ((*MSDOS_DIR_ENTRY_TYPE(entry) &
+                         MSDOS_LAST_LONG_ENTRY) == 0)
+                        continue;
+
+                    /*
+                     * Remember the start location of the long file name.
+                     */
+                    lfn_start =
+                      ((j * bts2rd) + i) / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
+                    
+                    /*
+                     * Get the number of entries so we can count down and
+                     * also the checksum of the short entry.
+                     */
+                    lfn_entries = (*MSDOS_DIR_ENTRY_TYPE(entry) &
+                                   MSDOS_LAST_LONG_ENTRY_MASK);
+                    lfn_checksum = *MSDOS_DIR_LFN_CHECKSUM(entry);
+                    memset (tmp_dirent.d_name, 0, sizeof(tmp_dirent.d_name));
+                }
+
+                /*
+                 * If the entry number or the check sum do not match
+                 * forget this series of long directory entries. These could
+                 * be orphaned entries depending on the history of the
+                 * disk.
+                 */
+                if ((lfn_entries != (*MSDOS_DIR_ENTRY_TYPE(entry) &
+                                     MSDOS_LAST_LONG_ENTRY_MASK)) ||
+                    (lfn_checksum != *MSDOS_DIR_LFN_CHECKSUM(entry)))
+                {
+                    lfn_start = FAT_FILE_SHORT_NAME;
+                    continue;
+                }
+             
+                /*
+                 * Extract the file name into the directory entry. The data is
+                 * stored in UNICODE characters (16bit). No translation is
+                 * currently supported.
+                 *
+                 * The DOS maximum length is 255 characters without the
+                 * trailing nul character. We need to range check the length to
+                 * fit in the directory entry name field.
+                 */
+                
+                lfn_entries--;
+                p = entry + 1;
+                o = lfn_entries * MSDOS_LFN_LEN_PER_ENTRY;
+                
+                for (q = 0; q < MSDOS_LFN_LEN_PER_ENTRY; q++)
+                {
+                    if (o >= (sizeof(tmp_dirent.d_name) - 1))
+                        break;
+                        
+                    tmp_dirent.d_name[o++] = *p;
+
+                    if (*p == '\0')
+                        break;
+
+                    switch (q)
+                    {
+                        case 4:
+                            p += 5;
+                            break;
+                        case 10:
+                            p += 4;
+                            break;
+                        default:
+                            p += 2;
+                            break;
+                    }
+                }
             }
-
-            tmp_fat_fd->info_cln = cur_cln;
-            tmp_fat_fd->info_ofs = i;
-
-            /* fill in dirent structure */
-            /* XXX: from what and in what d_off should be computed ?! */
-            tmp_dirent.d_off = start + cmpltd;
-            tmp_dirent.d_reclen = sizeof(struct dirent);
-            tmp_dirent.d_ino = tmp_fat_fd->ino;
-	    /*
-	     * convert dir entry from fixed 8+3 format (without dot)
-	     * to 0..8 + 1dot + 0..3 format
-	     */
-	    tmp_dirent.d_namlen = msdos_format_dirent_with_dot(
-              tmp_dirent.d_name,
-	      (char *) fs_info->cl_buf + i); /* src text */
-            memcpy(buffer + cmpltd, &tmp_dirent, sizeof(struct dirent));
-
-            iop->offset = iop->offset + sizeof(struct dirent);
-            cmpltd += (sizeof(struct dirent));
-            count -= (sizeof(struct dirent));
-
-            /* inode number extracted, close fat-file */
-            rc = fat_file_close(iop->pathinfo.mt_entry, tmp_fat_fd);
-            if (rc != RC_OK)
+            else
             {
-                rtems_semaphore_release(fs_info->vol_sema);
-                return rc;
+                fat_dir_pos_t dir_pos;
+              
+                /*
+                 * Skip active entries until get the entry to start from.
+                 */
+                if (start)
+                {
+                    lfn_start = FAT_FILE_SHORT_NAME;
+                    start--;
+                    continue;
+                }
+
+                /*
+                 * Move the entry to the return buffer
+                 *
+                 * unfortunately there is no method to extract ino except to
+                 * open fat-file descriptor :( ... so, open it
+                 */
+
+                /* get number of cluster we are working with */
+                rc = fat_file_ioctl(iop->pathinfo.mt_entry, fat_fd, F_CLU_NUM,
+                                    j * bts2rd, &cur_cln);
+                if (rc != RC_OK)
+                {
+                    rtems_semaphore_release(fs_info->vol_sema);
+                    return rc;
+                }
+
+                fat_dir_pos_init(&dir_pos);
+                dir_pos.sname.cln = cur_cln;
+                dir_pos.sname.ofs = i;
+                rc = fat_file_open(iop->pathinfo.mt_entry, &dir_pos, &tmp_fat_fd);
+                if (rc != RC_OK)
+                {
+                    rtems_semaphore_release(fs_info->vol_sema);
+                    return rc;
+                }
+
+                /* fill in dirent structure */
+                /* XXX: from what and in what d_off should be computed ?! */
+                tmp_dirent.d_off = start + cmpltd;
+                tmp_dirent.d_reclen = sizeof(struct dirent);
+                tmp_dirent.d_ino = tmp_fat_fd->ino;
+
+                /*
+                 * If a long file name check if the correct number of
+                 * entries have been found and if the checksum is correct.
+                 * If not return the short file name.
+                 */
+                if (lfn_start != FAT_FILE_SHORT_NAME)
+                {
+                    uint8_t  cs = 0;
+                    uint8_t* p = (uint8_t*) entry;
+                    int      i;
+
+                    for (i = 0; i < 11; i++, p++)
+                        cs = ((cs & 1) ? 0x80 : 0) + (cs >> 1) + *p;
+
+                    if (lfn_entries || (lfn_checksum != cs))
+                        lfn_start = FAT_FILE_SHORT_NAME;
+                }
+
+                if (lfn_start == FAT_FILE_SHORT_NAME)
+                {
+                    /*
+                     * convert dir entry from fixed 8+3 format (without dot)
+                     * to 0..8 + 1dot + 0..3 format
+                     */
+                    tmp_dirent.d_namlen = msdos_format_dirent_with_dot(
+                        tmp_dirent.d_name, entry); /* src text */
+                }
+                else
+                {
+                    tmp_dirent.d_namlen = strlen(tmp_dirent.d_name);
+                }
+                
+                memcpy(buffer + cmpltd, &tmp_dirent, sizeof(struct dirent));
+
+                iop->offset = iop->offset + sizeof(struct dirent);
+                cmpltd += (sizeof(struct dirent));
+                count -= (sizeof(struct dirent));
+
+                /* inode number extracted, close fat-file */
+                rc = fat_file_close(iop->pathinfo.mt_entry, tmp_fat_fd);
+                if (rc != RC_OK)
+                {
+                    rtems_semaphore_release(fs_info->vol_sema);
+                    return rc;
+                }
             }
-
+            
             if (count <= 0)
                 break;
         }
@@ -363,8 +498,8 @@ msdos_dir_read(rtems_libio_t *iop, void 
  *     RC_OK on success, or -1 if error occured (errno
  *     set apropriately).
  */
-off_t
-msdos_dir_lseek(rtems_libio_t *iop, off_t offset, int whence)
+rtems_off64_t
+msdos_dir_lseek(rtems_libio_t *iop, rtems_off64_t offset, int whence)
 {
     switch (whence)
     {
@@ -471,6 +606,24 @@ msdos_dir_sync(rtems_libio_t *iop)
     return rc;
 }
 
+/* msdos_dir_chmod --
+ *     Change the attributes of the directory. This currently does
+ *     nothing and returns no error.
+ *
+ * PARAMETERS:
+ *     pathloc - node description
+ *     mode - the new mode
+ *
+ * RETURNS:
+ *     RC_OK always
+ */
+int
+msdos_dir_chmod(rtems_filesystem_location_info_t *pathloc,
+                mode_t                            mode)
+{
+  return RC_OK;
+}
+
 /* msdos_dir_rmnod --
  *     Remove directory node.
  *
@@ -498,7 +651,7 @@ msdos_dir_rmnod(rtems_filesystem_locatio
         rtems_set_errno_and_return_minus_one(EIO);
 
     /*
-     * We deny attemp to delete open directory (if directory is current
+     * We deny attempts to delete open directory (if directory is current
      * directory we assume it is open one)
      */
     if (fat_fd->links_num > 1)
@@ -538,8 +691,7 @@ msdos_dir_rmnod(rtems_filesystem_locatio
      */
 
     /* mark file removed */
-    rc = msdos_set_first_char4file_name(pathloc->mt_entry, fat_fd->info_cln,
-                                        fat_fd->info_ofs,
+    rc = msdos_set_first_char4file_name(pathloc->mt_entry, &fat_fd->dir_pos,
                                         MSDOS_THIS_DIR_ENTRY_EMPTY);
     if (rc != RC_OK)
     {
Index: cpukit/libfs/src/dosfs/msdos_eval.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_eval.c,v
retrieving revision 1.8
diff -p -u -u -r1.8 msdos_eval.c
--- cpukit/libfs/src/dosfs/msdos_eval.c	4 Sep 2008 08:33:06 -0000	1.8
+++ cpukit/libfs/src/dosfs/msdos_eval.c	23 Apr 2009 07:54:40 -0000
@@ -82,9 +82,9 @@ msdos_eval_path(
     fat_file_fd_t                    *fat_fd = NULL;
     rtems_filesystem_location_info_t  newloc;
     int                               i = 0;
-    int                               len = 0;
+    int                               token_len = 0;
     msdos_token_types_t               type = MSDOS_CURRENT_DIR;
-    char                              token[MSDOS_NAME_MAX + 1];
+    const char                       *token;
 
     sc = rtems_semaphore_obtain(fs_info->vol_sema, RTEMS_WAIT,
                                 MSDOS_VOLUME_SEMAPHORE_TIMEOUT);
@@ -106,8 +106,8 @@ msdos_eval_path(
 
     while ((type != MSDOS_NO_MORE_PATH) && (type != MSDOS_INVALID_TOKEN))
     {
-        type = msdos_get_token(&pathname[i], token, &len);
-        i += len;
+        type = msdos_get_token(&pathname[i], &token, &token_len);
+        i += token_len;
 
         fat_fd = pathloc->node_access;
 
@@ -149,13 +149,13 @@ msdos_eval_path(
                             goto err;
 
                         rtems_semaphore_release(fs_info->vol_sema);
-                        return (*pathloc->ops->evalpath_h)(&(pathname[i-len]),
+                        return (*pathloc->ops->evalpath_h)(&(pathname[i-token_len]),
                                                            flags, pathloc);
                     }
                 }
                 else
                 {
-                    rc = msdos_find_name(pathloc, token);
+                  rc = msdos_find_name(pathloc, token, token_len);
                     if (rc != RC_OK)
                     {
                         if (rc == MSDOS_NAME_NOT_FOUND_ERR)
@@ -183,7 +183,7 @@ msdos_eval_path(
                  *  Otherwise find the token name in the present location and
                  * set the node access to the point we have found.
                  */
-                rc = msdos_find_name(pathloc, token);
+                rc = msdos_find_name(pathloc, token, token_len);
                 if (rc != RC_OK)
                 {
                     if (rc == MSDOS_NAME_NOT_FOUND_ERR)
@@ -264,8 +264,8 @@ msdos_eval4make(
     rtems_filesystem_location_info_t  newloc;
     msdos_token_types_t               type;
     int                               i = 0;
-    int                               len;
-    char                              token[ MSDOS_NAME_MAX + 1 ];
+    int                               token_len;
+    const char                       *token;
     bool                              done = false;
 
     sc = rtems_semaphore_obtain(fs_info->vol_sema, RTEMS_WAIT,
@@ -288,8 +288,8 @@ msdos_eval4make(
 
     while (!done)
     {
-        type = msdos_get_token(&path[i], token, &len);
-        i += len;
+        type = msdos_get_token(&path[i], &token, &token_len);
+        i += token_len;
         fat_fd = pathloc->node_access;
 
         switch (type)
@@ -330,13 +330,13 @@ msdos_eval4make(
                             goto err;
 
                         rtems_semaphore_release(fs_info->vol_sema);
-                        return (*pathloc->ops->evalformake_h)(&path[i-len],
+                        return (*pathloc->ops->evalformake_h)(&path[i-token_len],
                                                               pathloc, name);
                     }
                 }
                 else
                 {
-                    rc = msdos_find_name(pathloc, token);
+                    rc = msdos_find_name(pathloc, token, token_len);
                     if (rc != RC_OK)
                     {
                         if (rc == MSDOS_NAME_NOT_FOUND_ERR)
@@ -361,10 +361,10 @@ msdos_eval4make(
                 }
 
                 /*
-                 *  Otherwise find the token name in the present location and
+                 * Otherwise find the token name in the present location and
                  * set the node access to the point we have found.
                  */
-                rc = msdos_find_name(pathloc, token);
+                rc = msdos_find_name(pathloc, token, token_len);
                 if (rc)
                 {
                     if (rc != MSDOS_NAME_NOT_FOUND_ERR)
@@ -396,7 +396,7 @@ msdos_eval4make(
         }
     }
 
-    *name = &path[i - len];
+    *name = &path[i - token_len];
 
     /*
      * We have evaluated the path as far as we can.
Index: cpukit/libfs/src/dosfs/msdos_file.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_file.c,v
retrieving revision 1.11
diff -p -u -u -r1.11 msdos_file.c
--- cpukit/libfs/src/dosfs/msdos_file.c	9 Mar 2009 14:11:23 -0000	1.11
+++ cpukit/libfs/src/dosfs/msdos_file.c	23 Apr 2009 07:54:40 -0000
@@ -223,8 +223,8 @@ msdos_file_write(rtems_libio_t *iop,cons
  *     new offset on success, or -1 if error occured (errno set
  *     appropriately).
  */
-off_t
-msdos_file_lseek(rtems_libio_t *iop, off_t offset, int whence)
+rtems_off64_t
+msdos_file_lseek(rtems_libio_t *iop, rtems_off64_t offset, int whence)
 {
     int                rc = RC_OK;
     rtems_status_code  sc = RTEMS_SUCCESSFUL;
@@ -302,7 +302,7 @@ msdos_file_stat(
  *     RC_OK on success, or -1 if error occured (errno set appropriately).
  */
 int
-msdos_file_ftruncate(rtems_libio_t *iop, off_t length)
+msdos_file_ftruncate(rtems_libio_t *iop, rtems_off64_t length)
 {
     int                rc = RC_OK;
     rtems_status_code  sc = RTEMS_SUCCESSFUL;
@@ -444,6 +444,24 @@ msdos_file_ioctl(rtems_libio_t *iop,uint
     return rc;
 }
 
+/* msdos_file_chmod --
+ *     Change the attributes of the file. This currently does
+ *     nothing and returns no error.
+ *
+ * PARAMETERS:
+ *     pathloc - node description
+ *     mode - the new mode
+ *
+ * RETURNS:
+ *     RC_OK always
+ */
+int
+msdos_file_chmod(rtems_filesystem_location_info_t *pathloc,
+                 mode_t                            mode)
+{
+  return RC_OK;
+}
+
 /* msdos_file_rmnod --
  *     Remove node associated with a file - set up first name character to
  *     predefined value(and write it to the disk), and mark fat-file which
@@ -469,8 +487,8 @@ msdos_file_rmnod(rtems_filesystem_locati
         rtems_set_errno_and_return_minus_one(EIO);
 
     /* mark file removed */
-    rc = msdos_set_first_char4file_name(pathloc->mt_entry, fat_fd->info_cln,
-                                        fat_fd->info_ofs,
+    rc = msdos_set_first_char4file_name(pathloc->mt_entry,
+                                        &fat_fd->dir_pos,
                                         MSDOS_THIS_DIR_ENTRY_EMPTY);
     if (rc != RC_OK)
     {
